using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using GIOcsWrapperNS;

namespace PPC_E4_0300dotNetDemo
{
    public partial class Form1 : Form
    {
        private GIOcsWrapper deviceGIOcsWrapper = new GIOcsWrapper();

        const Byte PORT_IOBLK_DAT	= 0;
        const Byte PORT_IOBLK_CFG	= 1;	
        const Byte PORT_COM_C_MODE	= 2;	
        const Byte PORT_SYM_A7	    = 3;
        const Byte PORT_SYP_A6      = 4;
        const Byte PORT_SXM_A5      = 5;
        const Byte PORT_SXP_A4      = 6;	
        const Byte PORT_ANLMIN	    = 7;
        const Byte PORT_ANLMAX	    = 8;
        const Byte PORT_BRIGHT 	    = 9;
        const Byte PORT_TONE        = 10;


        public Form1()
        {
            InitializeComponent();

            if (deviceGIOcsWrapper.OpenDevice())
            {

            }
            else
                MessageBox.Show("   Unable to Open GIO driver.   ");

        }

        private void read_status_button_Click(object sender, EventArgs e)
        {
            // Read the value from status port.
            Byte byValue = deviceGIOcsWrapper.ReadValue(PORT_IOBLK_DAT);
            // show the status of the 4 io port lines.
            this.checkBox9.Checked = (byValue & 1) > 0;
            this.checkBox10.Checked = (byValue & 2) > 0;
            this.checkBox11.Checked = (byValue & 4) > 0;
            this.checkBox12.Checked = (byValue & 8) > 0;

            UInt16 wValue = deviceGIOcsWrapper.Read16bitValue(PORT_SXP_A4);
            textBoxAnl04.Text = Convert.ToString(wValue);

            wValue = deviceGIOcsWrapper.Read16bitValue(PORT_SXM_A5);
            textBoxAnl05.Text = Convert.ToString(wValue);

            wValue = deviceGIOcsWrapper.Read16bitValue(PORT_SYP_A6);
            textBoxAnl06.Text = Convert.ToString(wValue);

            wValue = deviceGIOcsWrapper.Read16bitValue(PORT_SYM_A7);
            textBoxAnl07.Text = Convert.ToString(wValue);

            wValue = deviceGIOcsWrapper.Read16bitValue(PORT_ANLMIN);
            textBox1.Text = Convert.ToString(wValue);

            wValue = deviceGIOcsWrapper.Read16bitValue(PORT_ANLMAX);
            textBox2.Text = Convert.ToString(wValue);
        }

        private void dig_out_btn_Click(object sender, EventArgs e)
        {
            Byte byValue = 0;
            if (this.checkBox1.Checked) byValue |= 1;
            if (this.checkBox2.Checked) byValue |= 2;
            if (this.checkBox3.Checked) byValue |= 4;
            if (this.checkBox4.Checked) byValue |= 8;
            deviceGIOcsWrapper.WriteValue(PORT_IOBLK_CFG, byValue);

            byValue = 0;
            if (this.checkBox5.Checked) byValue |= 1;
            if (this.checkBox6.Checked) byValue |= 2;
            if (this.checkBox7.Checked) byValue |= 4;
            if (this.checkBox8.Checked) byValue |= 8;
            deviceGIOcsWrapper.WriteValue(PORT_IOBLK_DAT, byValue);
        }


        private void vScrollBar1_ValueChanged(object sender, EventArgs e)
        {
            Byte byValue = (Byte)this.vScrollBar1.Value;
            deviceGIOcsWrapper.WriteValue(PORT_BRIGHT, byValue);
        }        
        
        private void vScrollBar2_ValueChanged(object sender, EventArgs e)
        {
            Byte byValue = (Byte)this.vScrollBar2.Value;
            deviceGIOcsWrapper.WriteValue(PORT_TONE, byValue);
        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            Byte byValue = (Byte)this.numericUpDown1.Value;
            deviceGIOcsWrapper.WriteValue(PORT_COM_C_MODE, byValue);
        }
    }
}